Loading...
Searching...
No Matches
factorTesting.h File Reference

Evaluate derivatives of a nonlinear factor numerically. More...

Go to the source code of this file.

## Namespaces

namespace | gtsam
| Global functions in a separate testing namespace.

## Macros

#define | EXPECT_CORRECT_FACTOR_JACOBIANS(factor, values, numerical_derivative_step, tolerance)
| Check the Jacobians produced by a factor against finite differences.

## Functions

JacobianFactor | gtsam::linearizeNumerically (const NoiseModelFactor &factor, const Values &values, double delta=1e-5)
| Linearize a nonlinear factor using numerical differentiation The benefit of this method is that it does not need to know what types are involved to evaluate the factor.
bool | gtsam::internal::testFactorJacobians (const std::string &name_, const NoiseModelFactor &factor, const gtsam::Values &values, double delta, double tolerance)

## Detailed Description

Evaluate derivatives of a nonlinear factor numerically.

Date
  September 18, 2014

Author
  Frank Dellaert
  Paul Furgale

## Macro Definition Documentation

## EXPECT_CORRECT_FACTOR_JACOBIANS

#define EXPECT_CORRECT_FACTOR_JACOBIANS | ( |  | factor,
|  |  | values,
|  |  | numerical_derivative_step,
|  |  | tolerance )

Value:
{ EXPECT(gtsam::internal::testFactorJacobians(name_, factor, values, numerical_derivative_step, tolerance)); }

Check the Jacobians produced by a factor against finite differences.

Parameters

  factor | The factor to test.
  values | Values filled in for testing the Jacobians.
  numerical_derivative_step | The step to use when computing the numerical derivative Jacobians
  tolerance | The numerical tolerance to use when comparing Jacobians.